/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2013 by Kijineko Inc.
 *  Copyright (C) 2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: sqlite3_toppers.c 58 2013-04-12 00:36:18Z ertl-honda $
 */

/*
 * ʲΥޥɬפ˱Ƥ⤷ʤƤ褤
 */
/* #define SQLITE_OMIT_DEPRECATED 1     // 侩APIά */
/* #define SQLITE_OMIT_FLOATING_POINT 1 // ư64ӥå */
#define NO_GETTOD 1                     /* gettimeofdayؿ̵ */

/*
 * TOPPERS/ASPͥư뤿
 */
#define SQLITE_OS_UNIX 1      /* UNIXѤΥɤ */
#define SQLITE_DISABLE_LFS 1  /* 2GBۤեϰʤ */
#define SQLITE_HOMEGROWN_RECURSIVE_MUTEX 1 /* ƵŪʥߥ塼ƥåOSǤϤʤSQLiteμȤ */
#define SQLITE_OMIT_WAL 1     /* mmapˤޥåץɥեȤʤ */
#define SQLITE_OMIT_LOAD_EXTENSION 1 /* ͭ饤֥Υʥߥåǥ󥰤ѤǽѤʤ */
#define SQLITE_OMIT_AUTHORIZATION 1 /* AUTHORIZATIONǽȤʤ */
#define SQLITE_UNIX_THREADS 1 /* UNIXΥåɤ */
#define SQLITE_THREADSAFE 1   /* åɥդ */

/* pthread.hŬڤʤΤˤ뤿 */
#define _POSIX_THREADS  1   
#define _UNIX98_THREAD_MUTEX_ATTRIBUTES 1

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <pthread.h>
#include <errno.h>
#include <limits.h>

#pragma GCC diagnostic ignored "-Wunused-value"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#pragma GCC diagnostic ignored "-Wunused-function"

#ifndef TOPPERS_SQLITE_OMIT_DEFAULT_SYSCALL
#include <t_stddef.h>
#include <syssvc/serial.h>
int open(const char *file, int flags, ...) { return -1; }
int close(int fd) { return -1; }
off_t lseek(int __fildes, off_t __offset, int __whence ) { return -1; };
int kill(pid_t pid, int sig) { return -1; };
int getpid(void) { return -1; };
int access(const char *file, int mode) { return -1; }
char *getcwd(char *s, size_t n) { return NULL; }
int stat(const char *file, struct stat* pstat) { return -1; }
int fstat(int fd, struct stat* pstat) { return -1; }
int ftruncate(int fd, off_t pos) { return -1; }
int fcntrl(int fd, int cmd, ...) { return -1; }
ssize_t read(int fd, void *buf, size_t n) { return -1; }
ssize_t write(int fd, const void *buf, size_t n)
{
	if (fd == 1 || fd == 2)
		return serial_wri_dat(1, buf, n);
	return -1;
}
int fchmod(int fd, mode_t mode) { return -1; }
int unlink(const char *file) { return -1; }
int mkdir(const char *dir, mode_t mode) { return -1; }
int rmdir(const char *dir) { return -1; }
int fchown(int fd, uid_t uid, gid_t gid) { return -1; }
mode_t umask(mode_t mode) { return 022; }
#endif /*  TOPPERS_SQLITE_OMIT_DEFAULT_SYSCALL */

#include <kernel.h>
#include "kernel_cfg.h"

#if NO_GETTOD && !defined(TOPPERS_SQLITE_OMIT_DEFAULT_TIME)

time_t time(time_t *timer)
{
  if (timer != NULL)
    *timer = (time_t)-1;
  return (time_t)-1;
}

#endif  /* NO_GETTOD && !defined(TOPPERS_SQLITE_OMIT_DEFAULT_TIME) */

#if SQLITE_UNIX_THREADS && !defined(TOPPERS_SQLITE_OMIT_DEFAULT_PTHREAD)

pthread_t pthread_self(void)
{
  ID tskid = 0;
  get_tid(&tskid);
  return (pthread_t)tskid;
}

int pthread_equal(pthread_t lhs, pthread_t rhs)
{
  if (lhs < 1 || TNUM_TSKID < lhs)
    return 0;
  return lhs == rhs;
}

static ID sqlite3_toppers_mutexes[] =
{
  SQLITE_SEMID1,
  SQLITE_SEMID2,
  SQLITE_SEMID3,
  SQLITE_SEMID4,
  SQLITE_SEMID5,
  SQLITE_SEMID6,
};

int pthread_mutex_init(pthread_mutex_t *mutex, const pthread_mutexattr_t *mutexattr)
{
  size_t i;
  for (i = 0; i < sizeof(sqlite3_toppers_mutexes) / sizeof(sqlite3_toppers_mutexes[0]); i++)
  {
    if (sqlite3_toppers_mutexes[i] != 0)
    {
      *mutex = sqlite3_toppers_mutexes[i];
      sqlite3_toppers_mutexes[i] = 0;
      return 0;
    }
  }
  return -1;
}

int pthread_mutex_lock(pthread_mutex_t *mutex)
{
  ER er;
  if (*mutex == (pthread_mutex_t)PTHREAD_MUTEX_INITIALIZER)
    pthread_mutex_init(mutex, NULL);
  er = wai_sem((ID)*mutex);
  if (MERCD(er) == E_ID)
    errno = EINVAL;
  return er;
}

int pthread_mutex_trylock(pthread_mutex_t *mutex)
{
  ER er;
  if (*mutex == (pthread_mutex_t)PTHREAD_MUTEX_INITIALIZER)
    pthread_mutex_init(mutex, NULL);
  er = pol_sem((ID)*mutex);
  switch (MERCD(er))
  {
  case E_ID:
    errno = EINVAL;
    break;
  case E_TMOUT:
    errno = EBUSY;
    break;
  }
  return er;
}

int pthread_mutex_unlock(pthread_mutex_t *mutex)
{
  ER er = sig_sem((ID)*mutex);
  if (MERCD(er) == E_ID)
    errno = EINVAL;
  return er;
}

int pthread_mutex_destroy(pthread_mutex_t *mutex)
{
  size_t i;
  for (i = 0; i < sizeof(sqlite3_toppers_mutexes) / sizeof(sqlite3_toppers_mutexes[0]); i++)
  {
    if (sqlite3_toppers_mutexes[i] == 0)
    {
      sqlite3_toppers_mutexes[i] = *mutex;
      ini_sem(*mutex);
      *mutex = 0;
      return 0;
    }
  }
  
  return -1;
}

#endif  /* SQLITE_UNIX_THREADS && !defined(TOPPERS_SQLITE_OMIT_DEFAULT_PTHREAD) */

uid_t getuid(void)
{
  return 10000;
}

uid_t geteuid(void)
{
  return 10000;
}

unsigned int sleep(unsigned int t)
{
  SYSTIM t1, t2;

  get_tim(&t1);
  if (dly_tsk(t * 1000) != E_OK)
  {
    get_tim(&t2);
    return (t - (t2 - t1) + 999) / 1000;
  }
  return 0;
}

int utimes(const char *filename, const struct timeval times[2])
{
  return -1;
}

int fsync(int fd)
{
  return -1;
}

/* SQLite */
#include "sqlite3.c"

